/*
 *  Copyright (C) 2008 hiNt <h1nt@bk.ru>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package mpe;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Vector;
import javax.microedition.rms.RecordStore;

public class Database {

    private static final String TEMPLATES_STORE = "mpe.tmpl";
    private static final String CONFIG_STORE = "mpe.cfg";
    private static Vector templates;
    // Настройки языка
    public static String lang = "chinese1.lang";
    // Настройки интерфейса
    public static boolean linenum = true;
    public static boolean highlight = true;      
    public static boolean indentation=true;
    public static boolean rls = false;
    public static int checkdelay=3;
    public static String lastsession = "";
    public static int fontFace = 0;
    public static int fontSize = 0;
    // Настройки редактора
    public static int cyrLayout = 0;
    public static int separator = 0;
    public static String template = "import javax.microedition.lcdui.Display;^nimport javax.microedition.lcdui.Form;^nimport javax.microedition.midlet.MIDlet;^n^npublic class HelloWorld extends MIDlet {^n  public Display d = Display.getDisplay(this);^n  public void startApp() {^n    d.setCurrent(new Form(\"hello Agrj.cn!\"));^n  }^n  public void pauseApp() {  }^n  public void destroyApp(boolean f) {^n    notifyDestroyed();^n  }^n}";
    public static int templLine = 2;

    public static void load() {
        RecordStore rs;
        try {
            rs = RecordStore.openRecordStore(CONFIG_STORE, true);
            DataInputStream dis;
            dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(1)));
            lang = dis.readUTF();
            dis.close();

            dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(2)));
            linenum = dis.readBoolean();
            highlight = dis.readBoolean();
            indentation= dis.readBoolean();
            rls = dis.readBoolean();
            checkdelay=dis.readInt();
            lastsession = dis.readUTF();
            fontFace = dis.readInt();
            fontSize = dis.readInt();
            dis.close();

            dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(3)));
            cyrLayout = dis.readInt();
            separator = dis.readInt();
            template = dis.readUTF();
            templLine = dis.readInt();
            dis.close();
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                RecordStore.deleteRecordStore(CONFIG_STORE);
            } catch (Exception ex) {
            }
            try {
                rs = RecordStore.openRecordStore(CONFIG_STORE, true);
                byte[] temp = new byte[0];
                rs.addRecord(temp, 0, temp.length);
                rs.addRecord(temp, 0, temp.length);
                rs.addRecord(temp, 0, temp.length);
                rs.closeRecordStore();
                saveLang();
                saveInterface();
                saveEditor();
            } catch (Exception ex) {
            }
        }
    }

    public static void saveLang() {
        try {
            RecordStore rs = RecordStore.openRecordStore(CONFIG_STORE, true);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            DataOutputStream dos = new DataOutputStream(baos);
            dos.writeUTF(lang);
            byte[] temp = baos.toByteArray();
            dos.close();
            baos.close();
            rs.setRecord(1, temp, 0, temp.length);
            rs.closeRecordStore();
        } catch (Exception ex) {
        }
    }

    public static void saveInterface() {
        try {
            RecordStore rs = RecordStore.openRecordStore(CONFIG_STORE, true);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            DataOutputStream dos = new DataOutputStream(baos);
            dos.writeBoolean(linenum);
            dos.writeBoolean(highlight);
            dos.writeBoolean(indentation);
            dos.writeBoolean(rls);
            dos.writeInt(checkdelay);
            dos.writeUTF(lastsession);
            dos.writeInt(fontFace);
            dos.writeInt(fontSize);
            byte[] temp = baos.toByteArray();
            dos.close();
            baos.close();
            rs.setRecord(2, temp, 0, temp.length);
            rs.closeRecordStore();
        } catch (Exception ex) {
        }
    }

    public static void saveEditor() {
        try {
            RecordStore rs = RecordStore.openRecordStore(CONFIG_STORE, true);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            DataOutputStream dos = new DataOutputStream(baos);
            dos.writeInt(cyrLayout);
            dos.writeInt(separator);
            dos.writeUTF(template);
            dos.writeInt(templLine);
            byte[] temp = baos.toByteArray();
            dos.close();
            baos.close();
            rs.setRecord(3, temp, 0, temp.length);
            rs.closeRecordStore();
        } catch (Exception ex) {
        }
    }

    public static void loadTemplates() {
        try {
            RecordStore rs = RecordStore.openRecordStore(TEMPLATES_STORE, true);
            templates = new Vector();
            if (rs.getNumRecords() > 0) {
                byte[] record = rs.enumerateRecords(null, null, false).nextRecord();
                DataInputStream dis = new DataInputStream(new ByteArrayInputStream(record));
                int count = dis.readInt();

                for (int i = 0; i < count; i++) {
                    templates.addElement(dis.readUTF());
                    templates.addElement(new Integer(dis.readInt()).toString());
                }
                dis.close();
            }
            rs.closeRecordStore();
        } catch (Exception e) {
        }
    }

    public static void saveTemplates() {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);
        try {
            dos.writeInt(templates.size() / 2);
            for (int i = 0; i < templates.size() / 2; i++) {
                dos.writeUTF((String) templates.elementAt(i * 2));
                dos.writeInt(Integer.parseInt(templates.elementAt(i * 2 + 1).toString()));
            }
            dos.close();
            baos.close();

            RecordStore.deleteRecordStore(TEMPLATES_STORE);
            RecordStore rs = RecordStore.openRecordStore(TEMPLATES_STORE, true);
            byte[] bytes = baos.toByteArray();
            rs.addRecord(bytes, 0, bytes.length);
            rs.closeRecordStore();
        } catch (Exception e) {
        }
    }

    public static void insertTemplate(int idx, Document d) {
        d.Insert(Utils.processMacros(templates.elementAt(idx * 2).toString()));
        int b = Integer.parseInt(templates.elementAt(idx * 2 + 1).toString());
        if (b <= templates.elementAt(idx * 2).toString().length()) {
            for (int i = 0; i < b; i++) {
                d.moveCursor(0);
            }
        }
    }

    public static void addTemplate(String text, String getBack) {
        templates.addElement(text);
        templates.addElement(getBack);
    }

    public static void editTemplate(int idx, String text, String getBack) {
        templates.setElementAt(text, idx * 2);
        templates.setElementAt(getBack, idx * 2 + 1);
    }

    public static void delTemplate(int idx) {
        templates.removeElementAt(idx * 2);
        templates.removeElementAt(idx * 2);
    }

    public static String[] getTemplates() {
        String[] s = new String[templates.size() / 2];
        for (int i = 0; i < templates.size() / 2; i++) {
            s[i] = templates.elementAt(i * 2).toString();
        }
        return s;
    }

    public static String getTemplateStr(int idx) {
        return templates.elementAt(idx * 2).toString();
    }
    
    public static String getTemplateInt(int idx) {
        return templates.elementAt(idx * 2 + 1).toString();
    }
}
