
package mpe;


import java.io.InputStream;
import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;

import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;

import net.sf.zipme.ZipArchive;
import net.sf.zipme.ZipEntry;






public class MPE extends MIDlet implements CommandListener {

    private final String VERSION = "2.0";
    public static final int MENU = -2;
    public static final int MENU_WORKSPACE = -1;
    public static final int MENU_MAIN = 0;
    public static final int MENU_FILE = 1;
    public static final int MENU_EDIT = 2;
    public static final int MENU_EDIT2 = 100;
    public static final int MENU_NAVI = 3;
    public static final int MENU_TEMPLATES = 4;
    public static final int MENU_OPTIONS = 5;
    public static final int MENU_LANGUAGE = 13;
    public static final int MENU_INTERFACE = 14;
    public static final int MENU_EDITOR = 15;
    public static final int MENU_SEARCH = 6;
    public static final int MENU_REPLACE = 7;
    public static final int MENU_LINEED = 8;
    public static final int MENU_GOTO = 9;
    public static final int MENU_ADDTEMPLATE = 10;
    public static final int MENU_EDITTEMPLATE = 11;
    public static final int MENU_ABOUT = 12;
    public static final int MENU_CHOOSEPACK=16;
    public static final int MENU_AUTOCOMPLETE=17;
    public static final int MENU_SHOWMORE=18;
    
    public Vector packagename;
    private int menu;
    private int parent;
    public Display display;
    public Workspace w;
    public List mainMenu;
    public LangResources lr;
    public Highlighter hlHighlighter;
    public FileManager fm;
    private TextField tfEdit1,  tfEdit2,  tfDocTemplate,  tfDocLine;
    private TextBox tbLineEditor;
    private ChoiceGroup cgSearchVar,  cgInterface,  cgFontFace,  cgFontSize,  cgLayout,  cgLineSeparator,cgChoosePackage,cgAutoComplete;
    private Command cmdBack,  cmdOk,  cmdSave,  cmdAddTemplate,  cmdDelTemplate,  cmdEditTemplate,cmdMore;
    private String buffer = "";
    public boolean running=true;


    public MPE() {
        Database.load();
        Database.loadTemplates();
        lr = new LangResources("/lang/" + Database.lang);
        packagename=new Vector();
        display = Display.getDisplay(this);
        w = new Workspace(this);
        fm = new FileManager(this);
        if (!Database.rls || Database.lastsession.equals("")) {
            w.createDocument();
        } else {
            fm.restore();
        }
        hlHighlighter = new Highlighter("/keyworld/j2me.stx");
        cmdMore=new Command("ϸ",Command.OK,1);
        cmdBack = new Command(lr.get("29"), Command.BACK, 99);
        cmdOk = new Command(lr.get("27"), Command.OK, 0);
        cmdSave = new Command(lr.get("8"), Command.OK, 0);
        cmdAddTemplate = new Command(lr.get("30"), Command.ITEM, 0);
        cmdEditTemplate = new Command(lr.get("31"), Command.ITEM, 1);
        cmdDelTemplate = new Command(lr.get("32"), Command.ITEM, 2);
    }

	public  byte[] LoadResource(String url)
	{
		byte msg[] = (byte[])null;
		try
		{
			InputStream is = "AAA".getClass().getResourceAsStream(url);
			if (is == null)
			{
				msg = (byte[])null;
			} else
			{
				int len = is.available();
				msg = new byte[len];
				for (int k = 0; k < len; k += is.read(msg, k, k + 10240 < len ? 10240 : len - k));
				is.close();
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
			msg = (byte[])null;
		}
		return msg;
	}
    public void startApp() {
    	
    	try 
    	{
	    	byte [] zipbyte=LoadResource("/api/emptyapi.zip");
	    	
	    	ZipArchive zf= new ZipArchive(zipbyte);
			
	    	Enumeration e = zf.entries();
	    	while(e.hasMoreElements())
	    	{
	    	    ZipEntry ze = (ZipEntry) e.nextElement();
	    	    if(!ze.isDirectory())
	    	    {
	    	    
	    	    	String name=new String(ze.getName().getBytes("ISO-8859-1"), "GB2312");
	    	    	int i=name.indexOf(".clazz");
	    	    	if(i>-1)
	    	    	{
	    	    		name=name.substring(0,name.indexOf(".clazz"));
	    	    	}
	    	    	packagename.addElement(name);
	    	    	

	    	    	

	    	    }
	    	 }
	    	System.out.println(packagename);
	    	
		} 
    	catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        showMenu(MENU_WORKSPACE,MENU);
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
        if (Database.rls) {
            Database.lastsession = "";
            for (int i = 0; i < w.getDocCount(); i++) {
                Database.lastsession += w.getDocumentNum(i).filename.equals("New") ? "" : w.getDocumentNum(i).filename + "\n";
            }
            if (!Database.lastsession.equals("")) {
                Database.lastsession = Database.lastsession.substring(0, Database.lastsession.length() - 1);
            }
        }
        Database.saveLang();
        Database.saveInterface();
        Database.saveEditor();
        notifyDestroyed();
        running=false;
    }

    public void commandAction(Command c, Displayable d) {
        if (c == List.SELECT_COMMAND) {
            if (menu == MENU_MAIN) {
                switch (mainMenu.getSelectedIndex()) {
                    case 0:
                        showMenu(MENU_FILE,MENU);
                        break;
                    case 1:
                        showMenu(MENU_EDIT,MENU);
                        break;
                    case 2:
                        showMenu(MENU_NAVI,MENU);
                        break;
                    case 3:
                        showMenu(MENU_TEMPLATES,MENU);
                        break;
                    case 4:
                        showMenu(MENU_OPTIONS,MENU);
                        break;
                    case 5:
                        showMenu(MENU_ABOUT,MENU);
                        break;
                    case 6:
                    	running=false;
                        destroyApp(false);
                        break;
                }
            } else if (menu == MENU_FILE) {
                if (mainMenu.getSelectedIndex() < 5) {
                    switch (mainMenu.getSelectedIndex()) {
                        case 0:
                            fm.show(true);
                            break;
                        case 1:
                            if (!w.getDocument().filename.equals("")) {
                            	
                            	System.out.println("save");
                            	fm.save(w.getDocument().filename);
                            	w.showMessage("ɹ");
  
                            }
                            else
                            {
                                fm.show(false);
                                
                            	
                            }
                            break;
                        case 2:
                            fm.show(false);
                            break;
                        case 3:
                            w.createDocument();
                            showMenu(MENU_WORKSPACE,MENU);
                            break;
                        case 4:
                            w.closeDocument();
                            showMenu(MENU_WORKSPACE,MENU);
                            break;
                    }
                } else if (mainMenu.getSelectedIndex() > 5) {
                    w.showDocument(mainMenu.getSelectedIndex() - 6);
                    showMenu(MENU_WORKSPACE,MENU);
                }
            } 
            
            
            else if (menu == MENU_EDIT2) {
                switch (mainMenu.getSelectedIndex()) {

                    case 0:
                        buffer = w.getDocument().Copy();
                        w.getDocument().endSelection();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 1:
                        buffer = w.getDocument().Cut();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 2:
                        w.getDocument().Insert(buffer);
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 3:
                        showMenu(MENU_SEARCH,MENU);
                        break;
                    case 4:
                        showMenu(MENU_REPLACE,MENU);
                        break;
                    case 5:
                    	w.getDocument().endSelection();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                }
            }
            else if (menu == MENU_EDIT) {
                switch (mainMenu.getSelectedIndex()) {
                    case 0:
                        w.getDocument().startSelection();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 1:
                        buffer = w.getDocument().Copy();
                        w.getDocument().endSelection();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 2:
                        buffer = w.getDocument().Cut();
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 3:
                        w.getDocument().Insert(buffer);
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 4:
                        showMenu(MENU_SEARCH,MENU);
                        break;
                    case 5:
                        showMenu(MENU_REPLACE,MENU);
                        break;
                    case 6:
                        showMenu(MENU_LINEED,MENU);
                        break;
                }
            } else if (menu == MENU_NAVI) {
                switch (mainMenu.getSelectedIndex()) {
                    case 0:
                        w.getDocument().setCursor(0, 0);
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 1:
                        w.getDocument().setCursor(w.getDocument().data.elementAt(w.getDocument().data.size() - 1).toString().length(), w.getDocument().data.size() - 1);
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 2:
                        w.getDocument().setCursor(0, w.getDocument().getCursor(Constants.CUR_Y));
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 3:
                        w.getDocument().setCursor(w.getDocument().data.elementAt(w.getDocument().getCursor(Constants.CUR_Y)).toString().length(), w.getDocument().getCursor(Constants.CUR_Y));
                        showMenu(MENU_WORKSPACE,MENU);
                        break;
                    case 4:
                        showMenu(MENU_GOTO,MENU);
                        break;
                }
            } else if (menu == MENU_TEMPLATES && mainMenu.getSelectedIndex() > - 1) {
                Database.insertTemplate(mainMenu.getSelectedIndex(), w.getDocument());
                showMenu(MENU_WORKSPACE,MENU);
            } else if (menu == MENU_OPTIONS) {
                switch (mainMenu.getSelectedIndex()) {
                    case 0:
                        showMenu(MENU_LANGUAGE,MENU);
                        break;
                    case 1:
                        showMenu(MENU_INTERFACE,MENU);
                        break;
                    case 2:
                        showMenu(MENU_EDITOR,MENU);
                        break;
                }
            } else if (menu == MENU_LANGUAGE) {
                switch (mainMenu.getSelectedIndex()) {
                    case 0:
                        Database.lang = "english.lang";
                        break;
                    case 1:
                        Database.lang = "chinese1.lang";
                        break;
                    case 2:
                        Database.lang = "chinese2.lang";
                        break;
                }
                lr.unload();
                lr = new LangResources("/lang/" + Database.lang);
                showMenu(MENU_MAIN,MENU);
            }
        }
        else if(c==cmdMore)
        {
        	showMenu(MPE.MENU_SHOWMORE,-1);
        }
        else if (c == cmdBack) {
        	if (parent==MENU_WORKSPACE)
        	{
                showMenu(MENU_WORKSPACE,MENU);
                System.gc();

        	}
        	else
        	{
	            switch (menu) {

	            	case MENU_EDIT2:
	                case MENU_MAIN:
	                    showMenu(MENU_WORKSPACE,MENU);
	                    System.gc();
	                    break;
	                case MENU_FILE:
	                case MENU_EDIT:
	                case MENU_NAVI:
	                case MENU_OPTIONS:
	                case MENU_ABOUT:
	                    showMenu(MENU_MAIN,MENU);
	                    break;
	                case MENU_SEARCH:
	                case MENU_REPLACE:
	                case MENU_LINEED:
	                    tfEdit1 = null;
	                    tfEdit2 = null;
	                    tbLineEditor = null;
	                    showMenu(MENU_EDIT,MENU);
	                    break;
	                case MENU_GOTO:
	                    showMenu(MENU_NAVI,MENU);
	                    break;
	                case MENU_ADDTEMPLATE:
	                case MENU_EDITTEMPLATE:
	                    tfEdit1 = null;
	                    tfEdit2 = null;
	                    showMenu(MENU_TEMPLATES,MENU);
	                    break;
	                case MENU_TEMPLATES:
	                    showMenu(MENU_MAIN,MENU);
	                    break;
	                case MENU_LANGUAGE:
	                case MENU_INTERFACE:
	                case MENU_EDITOR:
	                    showMenu(MENU_OPTIONS,MENU);
	                    break;
	            }
        	}
        } else if (c == cmdOk) {
            Form f;
            switch (menu) {
            	case MENU_AUTOCOMPLETE:
            		w.getDocument().Insert(cgAutoComplete.getString(cgAutoComplete.getSelectedIndex()));
            		showMenu(MENU_WORKSPACE,MENU);
            		break;
            	case MENU_CHOOSEPACK:

            		w.getDocument().setCursor(0, 0);
            		w.getDocument().Insert("import "+cgChoosePackage.getString(cgChoosePackage.getSelectedIndex())+";\n");

            		showMenu(MENU_WORKSPACE,MENU);
            		break;
                case MENU_SEARCH:
                    f = new Form(lr.get("15"));
                    f.append(lr.get("44"));
                    display.setCurrent(f);
                    for (int i = cgSearchVar.getSelectedIndex() == 2 ? 0 : w.getDocument().getCursor(Constants.CUR_Y); i < w.getDocument().data.size(); i = cgSearchVar.getSelectedIndex() == 1 ? i - 1 : i + 1) {
                        if (w.getDocument().data.elementAt(i).toString().toLowerCase().indexOf(tfEdit1.getString().toLowerCase()) > -1) {
                            w.getDocument().setCursor(0, i);
                            break;
                        }
                    }
                    showMenu(MENU_WORKSPACE,MENU);
                    break;
                case MENU_REPLACE:
                    f = new Form(lr.get("16"));
                    f.append(lr.get("45"));
                    display.setCurrent(f);
                    for (int i = cgSearchVar.getSelectedIndex() == 2 ? 0 : w.getDocument().getCursor(Constants.CUR_Y); i < w.getDocument().data.size();) {
                        if (w.getDocument().data.elementAt(i).toString().toLowerCase().indexOf(tfEdit1.getString().toLowerCase()) > -1) {
                            w.getDocument().data.setElementAt(new String(Utils.replace(w.getDocument().data.elementAt(i).toString(), tfEdit1.getString(), tfEdit2.getString())), i);
                        }
                        if (cgSearchVar.getSelectedIndex() == 1) {
                            i--;
                        } else {
                            i++;
                        }
                    }
                    showMenu(MENU_WORKSPACE,MENU);
                    break;
                case MENU_LINEED:
                    w.getDocument().data.setElementAt("", w.getDocument().getCursor(Constants.CUR_Y));
                    w.getDocument().setCursor(0, w.getDocument().getCursor(Constants.CUR_Y));
                    w.getDocument().Insert(tbLineEditor.getString());
                    showMenu(MENU_WORKSPACE,MENU);
                    break;
                case MENU_GOTO:
                    int n = Integer.parseInt(tfEdit1.getString()) - 1;
                    if (n >= 0 && n < w.getDocument().data.size()) {
                        w.getDocument().setCursor(0, n);
                    }
                    showMenu(MENU_WORKSPACE,MENU);
                    break;
                case MENU_ADDTEMPLATE:
                    Database.addTemplate(tfEdit1.getString(), tfEdit2.getString());
                    Database.saveTemplates();
                    showMenu(MENU_TEMPLATES,MENU);
                    break;
                case MENU_EDITTEMPLATE:
                    if (mainMenu.getSelectedIndex() > -1) {
                        Database.editTemplate(mainMenu.getSelectedIndex(), tfEdit1.getString(), tfEdit2.getString());
                    }
                    Database.saveTemplates();
                    showMenu(MENU_TEMPLATES,MENU);
                    break;
            }
            tfEdit1 = null;
            tfEdit2 = null;
        } else if (c == cmdSave) {
            switch (menu) {
                case MENU_INTERFACE:
                    Database.linenum = cgInterface.isSelected(0);
                    Database.highlight = cgInterface.isSelected(1);
                    Database.indentation = cgInterface.isSelected(2);               
                    Database.rls = cgInterface.isSelected(3);
                    Database.checkdelay=Integer.parseInt(tfEdit1.getString());
                    Database.fontFace = cgFontFace.getSelectedIndex();
                    Database.fontSize = cgFontSize.getSelectedIndex();
                    Graphic.a_boolean_static=(Database.fontFace==3)?true:false;

                    break;
                case MENU_EDITOR:
                    Database.cyrLayout = cgLayout.getSelectedIndex();
                    Database.separator = cgLineSeparator.getSelectedIndex();
                    Database.template = tfDocTemplate.getString();
                    Database.templLine = Integer.parseInt(tfDocLine.getString());
                    break;
            }
            showMenu(MENU_OPTIONS,MENU);
        } else if (c == cmdAddTemplate || c == cmdEditTemplate) {
            menu = c == cmdAddTemplate ? MENU_ADDTEMPLATE : MENU_EDITTEMPLATE;
            Form fReplace = new Form(c == cmdAddTemplate ? lr.get("46") : lr.get("47"));
            tfEdit1 = new TextField(lr.get("48"), c == cmdAddTemplate ? "" : Database.getTemplateStr(mainMenu.getSelectedIndex()), 100, TextField.ANY);
            tfEdit2 = new TextField(lr.get("49"), c == cmdAddTemplate ? "0" : Database.getTemplateInt(mainMenu.getSelectedIndex()), 5, TextField.NUMERIC);
            fReplace.append(tfEdit1);
            fReplace.append(tfEdit2);
            fReplace.addCommand(cmdOk);
            fReplace.addCommand(cmdBack);
            fReplace.setCommandListener(this);
            display.setCurrent(fReplace);
        } else if (c == cmdDelTemplate) {
            if (mainMenu.getSelectedIndex() > -1) {
                Database.delTemplate(mainMenu.getSelectedIndex());
                Database.saveTemplates();
                showMenu(MENU_TEMPLATES,MENU);
            }
        }
    }

    public void showMenu(int id,int parent) {
        menu = id;
        this.parent=parent;
        Form f;
        switch (id) {
            case MENU_WORKSPACE:
                display.setCurrent(w);
                break;
            case MENU_MAIN:
                mainMenu = new List("Jcreator V" + VERSION, List.IMPLICIT);
                mainMenu.append(lr.get("0"), null);
                mainMenu.append(lr.get("1"), null);
                mainMenu.append(lr.get("2"), null);
                mainMenu.append(lr.get("3"), null);
                mainMenu.append(lr.get("51"), null);
                mainMenu.append(lr.get("5"), null);
                mainMenu.append(lr.get("6"), null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_FILE:
                mainMenu = new List(lr.get("0"), List.IMPLICIT);
                mainMenu.append(lr.get("7"), null);
                mainMenu.append(lr.get("8"), null);
                mainMenu.append(lr.get("9"), null);
                mainMenu.append(lr.get("10"), null);
                mainMenu.append(lr.get("28"), null);
                mainMenu.append("----", null);
                for (int i = 0; i < w.getDocCount(); i++) {
                    mainMenu.append(w.getDocumentNum(i).filename, null);
                }
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
                
            case MENU_EDIT2:
                mainMenu = new List(lr.get("1"), List.IMPLICIT);
                mainMenu.append(lr.get("12"), null);
                mainMenu.append(lr.get("13"), null);
                mainMenu.append(lr.get("14"), null);
                mainMenu.append(lr.get("15"), null);
                mainMenu.append(lr.get("16"), null);
                mainMenu.append(lr.get("65"), null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
                
            case MENU_EDIT:
                mainMenu = new List(lr.get("1"), List.IMPLICIT);
                mainMenu.append(lr.get("11"), null);
                mainMenu.append(lr.get("12"), null);
                mainMenu.append(lr.get("13"), null);
                mainMenu.append(lr.get("14"), null);
                mainMenu.append(lr.get("15"), null);
                mainMenu.append(lr.get("16"), null);
                mainMenu.append(lr.get("17"), null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_NAVI:
                mainMenu = new List(lr.get("2"), List.IMPLICIT);
                mainMenu.append(lr.get("18"), null);
                mainMenu.append(lr.get("19"), null);
                mainMenu.append(lr.get("20"), null);
                mainMenu.append(lr.get("21"), null);
                mainMenu.append(lr.get("22"), null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_TEMPLATES:
                mainMenu = new List(lr.get("3"), List.IMPLICIT);
                String[] s = Database.getTemplates();
                for (int i = 0; i < s.length; i++) {
                    mainMenu.append(s[i], null);
                }
                mainMenu.addCommand(cmdAddTemplate);
                mainMenu.addCommand(cmdEditTemplate);
                mainMenu.addCommand(cmdDelTemplate);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_OPTIONS:
                mainMenu = new List(lr.get("51"), List.IMPLICIT);
                mainMenu.append(lr.get("4"), null);
                mainMenu.append(lr.get("52"), null);
                mainMenu.append(lr.get("54"), null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_ABOUT:
                f = new Form(lr.get("5"));
                f.append("Jcreator v" + VERSION + "\n"  +
                        "\n\n̳ http://agrj.cn\n\n"+
                        "ݼż+ȷ֣\nż+2ѱǵ)\nż+3ճ)\nż+4)\nż+5滻)\nż+6ת)\nż+7ٵƵؼλ)\n");
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
            case MENU_SEARCH:
                f = new Form(lr.get("15"));
                String selectedtext1=w.getDocument().GetSelectedText();
                w.getDocument().endSelection();
                tfEdit1 = new TextField(lr.get("36"), selectedtext1, 100, TextField.ANY);
                f.append(tfEdit1);
                cgSearchVar = new ChoiceGroup(lr.get("37"), ChoiceGroup.EXCLUSIVE);
                cgSearchVar.append(lr.get("38"), null);
                cgSearchVar.append(lr.get("39"), null);
                cgSearchVar.append(lr.get("40"), null);
                f.append(cgSearchVar);
                f.addCommand(cmdOk);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
            case MENU_REPLACE:
                f = new Form(lr.get("16"));
                String selectedtext2=w.getDocument().GetSelectedText();
                w.getDocument().endSelection();
                tfEdit1 = new TextField(lr.get("36"), selectedtext2, 100, TextField.ANY);
                f.append(tfEdit1);
                tfEdit2 = new TextField(lr.get("41"), "", 100, TextField.ANY);
                f.append(tfEdit2);
                cgSearchVar = new ChoiceGroup(lr.get("38"), ChoiceGroup.EXCLUSIVE);
                cgSearchVar.append(lr.get("38"), null);
                cgSearchVar.append(lr.get("39"), null);
                cgSearchVar.append(lr.get("40"), null);
                f.append(cgSearchVar);
                f.addCommand(cmdOk);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
            case MENU_LINEED:
                tbLineEditor = new TextBox(lr.get("42"), w.getDocument().data.elementAt(w.getDocument().getCursor(Constants.CUR_Y)).toString(), 5000, TextField.ANY);
                tbLineEditor.addCommand(cmdOk);
                tbLineEditor.addCommand(cmdBack);
                tbLineEditor.setCommandListener(this);
                display.setCurrent(tbLineEditor);
                break;
            case MENU_GOTO:
                f = new Form(lr.get("22"));
                tfEdit1 = new TextField(lr.get("43") + " " + new Integer(w.getDocument().data.size()).toString() + ")", "0", 10, TextField.NUMERIC);
                f.append(tfEdit1);
                f.addCommand(cmdOk);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
            case MENU_LANGUAGE:
                mainMenu = new List(lr.get("4"), List.IMPLICIT);
                mainMenu.append("English", null);
                mainMenu.append("()", null);
                mainMenu.append("()", null);
                mainMenu.addCommand(cmdBack);
                mainMenu.setCommandListener(this);
                display.setCurrent(mainMenu);
                break;
            case MENU_INTERFACE:
                f = new Form(lr.get("52"));
                tfEdit1=new TextField(lr.get("80"),"",2,TextField.NUMERIC);
                tfEdit1.setString(String.valueOf(Database.checkdelay));
                cgInterface = new ChoiceGroup(lr.get("52"), ChoiceGroup.MULTIPLE);
                cgInterface.append(lr.get("53"), null);
                cgInterface.append(lr.get("78"), null);
                cgInterface.append(lr.get("79"), null);
                cgInterface.append(lr.get("77"), null);
                if (Database.linenum) {
                    cgInterface.setSelectedIndex(0, true);
                   
                }
                if (Database.highlight) {
                    cgInterface.setSelectedIndex(1, true);
                }
                if (Database.indentation) {
                    cgInterface.setSelectedIndex(2, true);
                }

                if (Database.rls) {
                    cgInterface.setSelectedIndex(3, true);
                }
                f.append(cgInterface);
                
                f.append(tfEdit1);
                cgFontFace = new ChoiceGroup(lr.get("55"), ChoiceGroup.EXCLUSIVE);
                cgFontFace.append(lr.get("56"), null);
                cgFontFace.append(lr.get("57"), null);
                cgFontFace.append(lr.get("58"), null);
                cgFontFace.append(lr.get("81"), null);
                cgFontFace.setSelectedIndex(Database.fontFace, true);
                f.append(cgFontFace);
                cgFontSize = new ChoiceGroup(lr.get("59"), ChoiceGroup.EXCLUSIVE);
                cgFontSize.append(lr.get("60"), null);
                cgFontSize.append(lr.get("61"), null);
                cgFontSize.append(lr.get("62"), null);
                cgFontSize.setSelectedIndex(Database.fontSize, true);
                f.append(cgFontSize);
                f.addCommand(cmdSave);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
            case MENU_CHOOSEPACK:
                f = new Form("ѡ");
                cgChoosePackage = new ChoiceGroup("ѡ", ChoiceGroup.EXCLUSIVE);
                for(int i=0;i<w.matchpackage.size();i++){
                	cgChoosePackage.append(w.matchpackage.elementAt(i).toString().replace('/', '.'), null);
                }
                

                f.append(cgChoosePackage);
                f.addCommand(cmdOk);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
            	break;
            case MENU_AUTOCOMPLETE://Զ

            	f = new Form("Զ");
            	cgAutoComplete=new ChoiceGroup("Զ",ChoiceGroup.EXCLUSIVE);
            	for(int i=0;i<w.methodlist.size();i++){
            		cgAutoComplete.append(w.methodlist.elementAt(i).toString(), null);
                }
            	f.append(cgAutoComplete);
            	f.addCommand(cmdOk);
            	f.addCommand(cmdMore);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
            	break;
            case MENU_SHOWMORE:
            	f = new Form("");
            	f.append(w.methodinfo.elementAt(cgAutoComplete.getSelectedIndex()).toString());
                f.addCommand(cmdBack);
                f.setCommandListener(this);
            	display.setCurrent(f);            	
            	break;
            case MENU_EDITOR:
                f = new Form(lr.get("54"));
                cgLayout = new ChoiceGroup(lr.get("67"), ChoiceGroup.EXCLUSIVE);
                cgLayout.append(lr.get("68"), null);
                cgLayout.append(lr.get("69"), null);
                cgLayout.setSelectedIndex(Database.cyrLayout, true);
                f.append(cgLayout);
                cgLineSeparator = new ChoiceGroup(lr.get("76"), ChoiceGroup.EXCLUSIVE);
                cgLineSeparator.append("Unix (LF)", null);
                cgLineSeparator.append("Windows (CRLF)", null);
                cgLineSeparator.append("Macintosh (CR)", null);
                cgLineSeparator.setSelectedIndex(Database.separator, true);
                f.append(cgLineSeparator);
                tfDocTemplate = new TextField(lr.get("71"), Database.template, 1000, TextField.ANY);
                f.append(tfDocTemplate);
                tfDocLine = new TextField(lr.get("72"), new Integer(Database.templLine).toString(), 5, TextField.NUMERIC);
                f.append(tfDocLine);
                f.addCommand(cmdSave);
                f.addCommand(cmdBack);
                f.setCommandListener(this);
                display.setCurrent(f);
                break;
        }
    }
}
