package ru.andrew.jclazz.core;

import java.util.*;

public class MethodDescriptor
{
    private FieldDescriptor returnType;
    private Vector params;

    public MethodDescriptor(String descriptor) throws ClazzException
    {
        if (descriptor.charAt(0) != '(') throw new ClazzException("Invalid method descriptor");
        params = new Vector();
        int currentPos = 1;
        while (descriptor.charAt(currentPos) != ')')
        {
            int nextPos = currentPos;
            while (descriptor.charAt(nextPos) == '[') nextPos++;
            if (descriptor.charAt(nextPos) == 'L')
            {
                nextPos = descriptor.indexOf(';', nextPos);
            }
            nextPos++;
            params.addElement(new FieldDescriptor(descriptor.substring(currentPos, nextPos)));
            currentPos = nextPos;
        }
        returnType = new FieldDescriptor(descriptor.substring(currentPos + 1));
    }

    public FieldDescriptor getReturnType()
    {
        return returnType;
    }

    public Vector getParams()
    {
        return params;
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer();

        sb.append("(");
        for (Enumeration it = params.elements(); it.hasMoreElements();)
        {
            FieldDescriptor fd = (FieldDescriptor) it.nextElement();
            sb.append(fd.toString());
            if (it.hasMoreElements()) sb.append(", ");
        }
        sb.append(") : ");
        sb.append(returnType.toString());

        return sb.toString();
    }
}
