package ru.andrew.jclazz.core.io;

import java.io.*;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

public class ClazzOutputStream
{
    private DataOutputStream dos = null;

    public ClazzOutputStream(String fileName) throws Exception
    {
        dos = ((FileConnection)Connector.open(fileName)).openDataOutputStream();
    }

    public void close() throws IOException
    {
        if (dos != null) dos.close();
    }

    public void writeU1(int u1) throws IOException
    {
        dos.writeByte(u1);
    }

    public void writeU2(int u2) throws IOException
    {
        dos.writeShort(u2);
    }

    public void writeU4(long u4) throws IOException
    {
        dos.writeLong(u4);
    }

    public void writeDouble(double v) throws IOException
    {
        dos.writeDouble(v);
    }

    public void writeFloat(float v) throws IOException
    {
        dos.writeFloat(v);
    }

    public void writeInt(int v) throws IOException
    {
        dos.writeInt(v);
    }

    public void writeLong(long v) throws IOException
    {
        dos.writeLong(v);
    }

    public void writeUTF(String v) throws IOException
    {
        dos.writeUTF(v);
    }
}
