package ru.andrew.jclazz.core.signature;

import java.util.*;

/*
ClassSignature:
   <FormalTypeParameter+> ClassTypeSignature ClassTypeSignature*
   optional               superclass         interfaces
 */
public class ClassSignature
{
    private ClassTypeSignature superClass;
    private ClassTypeSignature[] interfaces;
    private FormalTypeParameter[] typeParameters;

    public ClassSignature(String signature)
    {
        StringBuffer sb = new StringBuffer(signature);
        if (signature.charAt(0) == '<')
        {
            sb.deleteCharAt(0);
            Vector ftps = new Vector();
            while (sb.charAt(0) != '>')
            {
                ftps.addElement(FormalTypeParameter.parse(sb));
            }
            typeParameters = new FormalTypeParameter[ftps.size()];
            ftps.copyInto(typeParameters);
            sb.deleteCharAt(0);
        }

        // Loading super class
        if (sb.length() > 0)
        {
            superClass = ClassTypeSignature.parse(sb);
        }
        Vector intfs = new Vector();
        while (sb.length() > 0)
        {
            intfs.addElement(ClassTypeSignature.parse(sb));
        }
        interfaces = new ClassTypeSignature[intfs.size()];
        intfs.copyInto(interfaces);
    }

    public ClassTypeSignature getSuperClass()
    {
        return superClass;
    }

    public ClassTypeSignature[] getInterfaces()
    {
        return interfaces;
    }

    public FormalTypeParameter[] getTypeParameters()
    {
        return typeParameters;
    }
}
