// Decompiled by Jad v1.5.8e2. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://kpdus.tripod.com/jad.html
// Decompiler options: packimports(3) fieldsfirst ansi space 
// Source File Name:   Highlighter.java

package mpe;
import java.io.DataInputStream;
import java.io.IOException;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;


public class Highlighter
{

	private String vKeywords[][];
	private int vColors[];
	private char quoteChar[];
	private String multiCommentStart;
	private String multiCommentEnd;
	private String singleComment;
	private Font font;
	static final short MAGIC = -5430;

	public Highlighter(String resource)
	{
		DataInputStream dis = new DataInputStream(getClass().getResourceAsStream(resource));
		font = Font.getFont(Database.fontFace != 0 ? Database.fontFace != 1 ? 32 : 64 : 0, 0, Database.fontSize != 0 ? ((int) (Database.fontSize != 1 ? 16 : 0)) : 8);
		try
		{
			if (dis.readShort() != -5430)
				throw new IllegalArgumentException("This is not Higlighter *.stx file!");
			int nCategories = dis.readInt();
			vColors = new int[nCategories];
			vKeywords = new String[nCategories][];
			for (int i = 0; i < nCategories; i++)
			{
				vColors[i] = dis.readInt();
				int nKeywords = dis.readInt();
				vKeywords[i] = new String[nKeywords];
				for (int j = 0; j < nKeywords; j++)
					vKeywords[i][j] = dis.readUTF();

			}

			int nQuotes = dis.readInt();
			quoteChar = new char[nQuotes];
			for (int i = 0; i < nQuotes; i++)
				quoteChar[i] = dis.readChar();

			multiCommentStart = dis.readUTF();
			multiCommentEnd = dis.readUTF();
			singleComment = dis.readUTF();
		}
		catch (IOException ioe)
		{
			ioe.printStackTrace();
		}
	}

	public void highlight(Graphics g, String text, int x, int y, int offet, boolean bError, int errStart, 
			int errEnd, boolean bMatch, int matchStart)
	{
		g.setFont(font);
		if (bError)
		{
			g.setColor(0xff0000);
			g.fillRect(Graphic.stringWidth(font, text.substring(0, errStart)) + x, y, Graphic.stringWidth(font, text.substring(errStart, errEnd)), Graphic.getHeight(font));
		}
		
		if (bMatch)
		{
			g.setColor(0xffff00);
			g.fillRect(Graphic.stringWidth(font, text.substring(0, matchStart)) + x, y, Graphic.stringWidth(font, "]"), Graphic.getHeight(font));
		}
		g.setColor(0);
		if(Database.highlight)
		{

			Graphic.drawString(g, text, x, y, offet);
			int i0 = 0;
			for (int j = 0; j < vKeywords.length; j++)
			{
				g.setColor(vColors[j]);
				i0 = 0;
				for (int i = 0; i < vKeywords[j].length; i++)
					while (i0 < text.length()) 
					{
						i0 = text.indexOf(vKeywords[j][i], i0);
						if (i0 < 0)
							break;
						char c = i0 + vKeywords[j][i].length() >= text.length() ? '.' : text.charAt(i0 + vKeywords[j][i].length());
						char c1 = i0 <= 0 ? '.' : text.charAt(i0 - 1);
						if (!isName(c) && !isName(c1))
						{
							int color = g.getColor();
							g.setColor(color);
							Graphic.drawSubstring(g, text, i0, vKeywords[j][i].length(), Graphic.stringWidth(font, text.substring(0, i0)) + x, y, offet);
						}
						i0++;
					}
	
			}
	
			g.setColor(32768);
			for (i0 = 0; i0 < text.length(); i0++)
			{
				i0 = text.indexOf(multiCommentStart, i0);
				if (i0 < 0)
					break;
				int i1 = text.indexOf(multiCommentEnd, i0 + 2);
				if (i1 < 0)
					i1 = text.length() - 2;
				int color = g.getColor();
				g.setColor(color);
				Graphic.drawSubstring(g, text, i0, (i1 - i0) + 2, Graphic.stringWidth(font, text.substring(0, i0)) + x, y, offet);
				i0 = i1;
			}
	
			i0 = text.indexOf(singleComment);
			if (i0 >= 0)
			{
				int color = g.getColor();
				g.setColor(color);
				Graphic.drawSubstring(g, text, i0, text.length() - i0, Graphic.stringWidth(font, text.substring(0, i0)) + x, y, offet);
			}
			g.setColor(0xff8000);
			for (int i = 0; i < quoteChar.length; i++)
				for (i0 = 0; i0 < text.length(); i0++)
				{
					i0 = text.indexOf(quoteChar[i], i0);
					if (i0 < 0)
						break;
					int i1 = text.indexOf(quoteChar[i], i0 + 1);
					if (i1 < 0)
						i1 = text.length() - 1;
					int color = g.getColor();
					g.setColor(color);
					Graphic.drawSubstring(g, text, i0, (i1 - i0) + 1, Graphic.stringWidth(font, text.substring(0, i0)) + x, y, offet);
					i0 = i1;
				}

			
		}
		else
		{
			g.drawString( text, x, y, offet);
		}
	}

	private boolean isName(char c)
	{
		return c >= '0' && c <= '9' || c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c == '_' || c == '$';
	}
}
